/*
 *
 *
 */
#ifndef __USB_H__
#define __USB_H__

//typedef union {
//	u_short W;
//	struct {
//		u_char L;
//		u_char H;
//	} WB;
//} WORD_BYTE;
//
/* bmRequestType.Dir */
#define REQUEST_HOST_TO_DEVICE     0
#define REQUEST_DEVICE_TO_HOST     1

/* bmRequestType.Type */
#define REQUEST_STANDARD           0
#define REQUEST_CLASS              1
#define REQUEST_VENDOR             2
#define REQUEST_RESERVED           3

/* bmRequestType.Recipient */
#define REQUEST_TO_DEVICE          0
#define REQUEST_TO_INTERFACE       1
#define REQUEST_TO_ENDPOINT        2
#define REQUEST_TO_OTHER           3

///* bmRequestType Definition */
//typedef union _REQUEST_TYPE {
//	struct _BM {
//		u_char Recipient:5;
//		u_char Type     :2;
//		u_char Dir      :1;
//	} BM;
//	u_char B;
//} REQUEST_TYPE;
//
/* USB Standard Request Codes */
#define USB_REQUEST_GET_STATUS                 0
#define USB_REQUEST_CLEAR_FEATURE              1
#define USB_REQUEST_SET_FEATURE                3
#define USB_REQUEST_SET_ADDRESS                5
#define USB_REQUEST_GET_DESCRIPTOR             6
#define USB_REQUEST_SET_DESCRIPTOR             7
#define USB_REQUEST_GET_CONFIGURATION          8
#define USB_REQUEST_SET_CONFIGURATION          9
#define USB_REQUEST_GET_INTERFACE             10
#define USB_REQUEST_SET_INTERFACE             11
#define USB_REQUEST_SYNC_FRAME                12

/* USB GET_STATUS Bit Values */
#define USB_GETSTATUS_SELF_POWERED           0x01
#define USB_GETSTATUS_REMOTE_WAKEUP          0x02
#define USB_GETSTATUS_ENDPOINT_STALL         0x01

/* USB Standard Feature selectors */
#define USB_FEATURE_ENDPOINT_STALL             0
#define USB_FEATURE_REMOTE_WAKEUP              1

/* USB Default Control Pipe Setup Packet */
typedef struct _USB_SETUP_PACKET {
	u_char        dir;
	u_char        type;
	u_char        recip;
	u_char        bRequest;
	u_short       wValue;
	u_short       wIndex;
	u_short       wLength;
} USB_SETUP_PACKET;

/* USB Descriptor Types */
#define USB_DEVICE_DESCRIPTOR_TYPE              1
#define USB_CONFIGURATION_DESCRIPTOR_TYPE       2
#define USB_STRING_DESCRIPTOR_TYPE              3
#define USB_INTERFACE_DESCRIPTOR_TYPE           4
#define USB_ENDPOINT_DESCRIPTOR_TYPE            5
#define USB_DEVICE_QUALIFIER_DESCRIPTOR_TYPE    6
#define USB_OTHER_SPEED_CONFIG_DESCRIPTOR_TYPE  7
#define USB_INTERFACE_POWER_DESCRIPTOR_TYPE     8

///* USB Device Classes */
//#define USB_DEVICE_CLASS_RESERVED              0x00
//#define USB_DEVICE_CLASS_AUDIO                 0x01
//#define USB_DEVICE_CLASS_COMMUNICATIONS        0x02
//#define USB_DEVICE_CLASS_HUMAN_INTERFACE       0x03
//#define USB_DEVICE_CLASS_MONITOR               0x04
//#define USB_DEVICE_CLASS_PHYSICAL_INTERFACE    0x05
//#define USB_DEVICE_CLASS_POWER                 0x06
//#define USB_DEVICE_CLASS_PRINTER               0x07
//#define USB_DEVICE_CLASS_STORAGE               0x08
//#define USB_DEVICE_CLASS_HUB                   0x09
//#define USB_DEVICE_CLASS_VENDOR_SPECIFIC       0xFF
//
/* bmAttributes in Configuration Descriptor */
#define USB_CONFIG_POWERED_MASK                0xC0
#define USB_CONFIG_BUS_POWERED                 0x80
#define USB_CONFIG_SELF_POWERED                0x40
#define USB_CONFIG_REMOTE_WAKEUP               0x20

///* bMaxPower in Configuration Descriptor */
//#define USB_CONFIG_POWER_MA(mA)              ((mA)/2)
//
///* bEndpointAddress in Endpoint Descriptor */
//#define USB_ENDPOINT_DIRECTION_MASK            0x80
//#define USB_ENDPOINT_OUT(addr)               ((addr) | 0x00)
//#define USB_ENDPOINT_IN(addr)                ((addr) | 0x80)
//
///* bmAttributes in Endpoint Descriptor */
//#define USB_ENDPOINT_TYPE_MASK                 0x03
//#define USB_ENDPOINT_TYPE_CONTROL              0x00
//#define USB_ENDPOINT_TYPE_ISOCHRONOUS          0x01
//#define USB_ENDPOINT_TYPE_BULK                 0x02
//#define USB_ENDPOINT_TYPE_INTERRUPT            0x03
//#define USB_ENDPOINT_SYNC_MASK                 0x0C
//#define USB_ENDPOINT_SYNC_NO_SYNCHRONIZATION   0x00
//#define USB_ENDPOINT_SYNC_ASYNCHRONOUS         0x04
//#define USB_ENDPOINT_SYNC_ADAPTIVE             0x08
//#define USB_ENDPOINT_SYNC_SYNCHRONOUS          0x0C
//#define USB_ENDPOINT_USAGE_MASK                0x30
//#define USB_ENDPOINT_USAGE_DATA                0x00
//#define USB_ENDPOINT_USAGE_FEEDBACK            0x10
//#define USB_ENDPOINT_USAGE_IMPLICIT_FEEDBACK   0x20
//#define USB_ENDPOINT_USAGE_RESERVED            0x30
//
///* USB Standard Device Descriptor */
//typedef struct _USB_DEVICE_DESCRIPTOR {
//	u_char  bLength;
//	u_char  bDescriptorType;
//	u_short bcdUSB;
//	u_char  bDeviceClass;
//	u_char  bDeviceSubClass;
//	u_char  bDeviceProtocol;
//	u_char  bMaxPacketSize0;
//	u_short idVendor;
//	u_short idProduct;
//	u_short bcdDevice;
//	u_char  iManufacturer;
//	u_char  iProduct;
//	u_char  iSerialNumber;
//	u_char  bNumConfigurations;
//} USB_DEVICE_DESCRIPTOR;
//
//#define USB_DEVICE_DESC_SIZE        (sizeof(USB_DEVICE_DESCRIPTOR))
//#define USB_DEVICE_DESC_SIZE       18
//
///* USB 2.0 Device Qualifier Descriptor */
//typedef struct _USB_DEVICE_QUALIFIER_DESCRIPTOR {
//	u_char  bLength;
//	u_char  bDescriptorType;
//	u_short bcdUSB;
//	u_char  bDeviceClass;
//	u_char  bDeviceSubClass;
//	u_char  bDeviceProtocol;
//	u_char  bMaxPacketSize0;
//	u_char  bNumConfigurations;
//	u_char  bReserved;
//} USB_DEVICE_QUALIFIER_DESCRIPTOR;
//
///* USB Standard Configuration Descriptor */
//typedef struct _USB_CONFIGURATION_DESCRIPTOR {
//	u_char  bLength;
//	u_char  bDescriptorType;
//	u_short wTotalLength;
//	u_char  bNumInterfaces;
//	u_char  bConfigurationValue;
//	u_char  iConfiguration;
//	u_char  bmAttributes;
//	u_char  MaxPower;
//} USB_CONFIGURATION_DESCRIPTOR;
//
//#define USB_CONFIGUARTION_DESC_SIZE (sizeof(USB_CONFIGURATION_DESCRIPTOR))
//
///* USB Standard Interface Descriptor */
//typedef struct _USB_INTERFACE_DESCRIPTOR {
//	u_char  bLength;
//	u_char  bDescriptorType;
//	u_char  bInterfaceNumber;
//	u_char  bAlternateSetting;
//	u_char  bNumEndpoints;
//	u_char  bInterfaceClass;
//	u_char  bInterfaceSubClass;
//	u_char  bInterfaceProtocol;
//	u_char  iInterface;
//} USB_INTERFACE_DESCRIPTOR;
//
//#define USB_INTERFACE_DESC_SIZE     (sizeof(USB_INTERFACE_DESCRIPTOR))
//
///* USB Standard Endpoint Descriptor */
//typedef struct _USB_ENDPOINT_DESCRIPTOR {
//	u_char  bLength;
//	u_char  bDescriptorType;
//	u_char  bEndpointAddress;
//	u_char  bmAttributes;
//	u_short wMaxPacketSize;
//	u_char  bInterval;
//} USB_ENDPOINT_DESCRIPTOR;
//
//#define USB_ENDPOINT_DESC_SIZE      (sizeof(USB_ENDPOINT_DESCRIPTOR))
//
///* USB String Descriptor */
//typedef struct _USB_STRING_DESCRIPTOR {
//	u_char  bLength;
//	u_char  bDescriptorType;
//	u_short bString/*[]*/;
//} USB_STRING_DESCRIPTOR;
//
///* USB Common Descriptor */
//typedef struct _USB_COMMON_DESCRIPTOR {
//	u_char  bLength;
//	u_char  bDescriptorType;
//} USB_COMMON_DESCRIPTOR;


#endif  /* __USB_H__ */
